package uy.edu.fing.chesstrack.communication;

import java.io.DataOutputStream;
import java.io.IOException;
import java.net.InetAddress;
import java.net.Socket;

import android.util.Log;

public class Client {

	private static final String TAG = "CLIENT";
	private static Client _clientInstance;

	private Socket serverSocket;
	private int _serverPort;
	private String _serverIp;

	//private BufferedReader input;
	private DataOutputStream output;

	protected Client(){

	}

	public static Client getInstance(){
		if(_clientInstance == null){
			_clientInstance = new Client();
		}
		return _clientInstance;
	}

	public void EstablishConnection(String serverIp, int serverPort) {
		Log.i(TAG, "init client-server communication");
		this._serverIp = serverIp;
		this._serverPort = serverPort;

		try {
			Log.i(TAG, "Server on " + this._serverIp + ":" + _serverPort);
			InetAddress serverAddr = InetAddress.getByName(this._serverIp);
			serverSocket = new Socket(serverAddr, _serverPort);

			// get stream to send data
			this.output = new DataOutputStream(this.serverSocket.getOutputStream());

			// get stream to receive data
			//this.input = new BufferedReader(new InputStreamReader(this.serverSocket.getInputStream()));
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public void SendData(String msg) {
		try {
			Log.i(TAG, "sending="+ msg);
			this.output.writeBytes(msg);
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	/*
 	public String ReceiveData() {
		try {
			String read = input.readLine();
			Log.i(TAG, "received="+ read);
			return read;
		} catch (IOException e) {
			e.printStackTrace();
			return null;
		}
	}
	*/

	public void Stop() {
		try {
			//input.close();
			output.close();
			serverSocket.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
